
// rsvna_one_and_two_port_calibration_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsvna_one_and_two_port_calibration_example.h"
#include "rsvna_one_and_two_port_calibration_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define CHECKERR(fcal) if ((rsvna_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsvna_one_and_two_port_calibration_exampleDlg dialog




Crsvna_one_and_two_port_calibration_exampleDlg::Crsvna_one_and_two_port_calibration_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsvna_one_and_two_port_calibration_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(true)
	, m_Reset(true)
	, m_Display(true)
	, m_PortSelector(0)
	, m_ConnectorType(0)
	, m_PortOneConnector(0)
	, m_PortTwoConnector(0)
	, m_CalKitName(_T("N 50 Ohm Ideal Kit"))
	, m_CalibrationFileName(_T("OSM1 TOSM12.cal"))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsvna_one_and_two_port_calibration_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_CBIndex(pDX, IDC_PORT_SELECTOR, m_PortSelector);
	DDX_CBIndex(pDX, IDC_CONN_TYPE, m_ConnectorType);
	DDX_CBIndex(pDX, IDC_PORT_ONE_CONN, m_PortOneConnector);
	DDX_CBIndex(pDX, IDC_PORT_TWO_CONN, m_PortTwoConnector);
	DDX_Text(pDX, IDC_CAL_KIT_NAME, m_CalKitName);
	DDX_Text(pDX, IDC_SAVE_CALIBRATION, m_CalibrationFileName);
}

BEGIN_MESSAGE_MAP(Crsvna_one_and_two_port_calibration_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsvna_one_and_two_port_calibration_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsvna_one_and_two_port_calibration_exampleDlg message handlers

BOOL Crsvna_one_and_two_port_calibration_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsvna_one_and_two_port_calibration_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsvna_one_and_two_port_calibration_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsvna_one_and_two_port_calibration_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	/* initialize driver */
    CHECKERR (rsvna_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
    
    /* switch device display on/off */
    CHECKERR( rsvna_SetAttributeViInt32 (m_InstrSession, "", RSVNA_ATTR_DISPLAY_UPDATE, m_Display));
    
	/* Set cal kit as active kit for N50 */
    CHECKERR (rsvna_ConfigureCalibrationKit (m_InstrSession, m_ConnectorType, (char *) ((LPCTSTR) W2A(m_CalKitName.LockBuffer()))));
    
    /* Select connectors for the ports*/
    CHECKERR (rsvna_ConfigureConnector (m_InstrSession, 1, 1, m_PortOneConnector));
    
    if (m_PortSelector == 1)
    {
        /* Select connectors for the ports */
        CHECKERR (rsvna_ConfigureConnector (m_InstrSession, 1, 2, m_PortTwoConnector));
    }
    
    /* Deactivates the calibration mode where the raw measurement data 
    of the standards is stored after the calibration is completed. */
    CHECKERR (rsvna_SetAttributeViBoolean (m_InstrSession, "Channel1", RSVNA_ATTR_REPEAT_PREVIOUS_CALIBRATION, VI_FALSE));
    
    if (m_PortSelector == 0)
    {
        /* Full one port = OSM
        Select cal procedure */
        CHECKERR (rsvna_SelectCalibrationType (m_InstrSession, 1, "Test SFK OSM 1", RSVNA_VAL_CALTYPE_FOP, 1, 0, 0, 0));
        
        /* Measure Standards */
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for OPEN calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_OPEN, 1, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for SHORT calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_SHORT, 1, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for MATCH calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_MATCH, 1, 0));
    
        /* Apply calibration */
        CHECKERR (rsvna_SaveCalibrationData (m_InstrSession, 1));
    }
    
    if (m_PortSelector == 1)
    {
        /* 2 port TOSM
        Select cal procedure */
        CHECKERR (rsvna_SelectCalibrationType (m_InstrSession, 1, "Test SFK TOSM 12", RSVNA_VAL_CALTYPE_TOSM, 1, 2, 0, 0));
        
        /* Measure Standards */
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for THROUGH calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_THR, 1, 2));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for OPEN port 1 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_OPEN, 1, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for SHORT port 1 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_SHORT, 1, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for MATCH port 1 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_MATCH, 1, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for OPEN port 2 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_OPEN, 2, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for SHORT port 2 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_SHORT, 2, 0));
        AfxMessageBox ( _T( "Connect/disconnect calibration unit for MATCH port 2 calibration step."));
        CHECKERR (rsvna_StartCalibration (m_InstrSession, 1, RSVNA_VAL_CALCOLLSTDGEN_MATCH, 2, 0));
    
        /* Apply calibration */
        CHECKERR (rsvna_SaveCalibrationData (m_InstrSession, 1)); 
    }
    /* Save cal file
    Save calibration in calibration file pool in directory
    C:\Rohde&Schwarz\Nwa\Calibration\Data
    the file name in the commands must not contain the path ! */
    CHECKERR (rsvna_CalibrationManager (m_InstrSession, 1, RSVNA_VAL_CORR_MAN_COPY, (char *) ((LPCTSTR) W2A(m_CalibrationFileName.LockBuffer())), ""));
        
    /* close session */
    cleanup(VI_FALSE);

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsvna_one_and_two_port_calibration_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsvna_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsvna_error_message(m_InstrSession, rsvna_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsvna_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsvna_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	if (m_InstrSession != NULL)
		rsvna_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}